﻿--[[
- ru:  ТитанПанель - Дистанция Камеры: Изменяет максимальную дальность обзора камеры. 
- en:  TitanPanel - Camera Distance: Sets a maximum range of the camera distance.

Author: Wishko
E-mail: Wish1250@gmail.com
Date: 9 june 2010; upd: 8 jule 2010
For users: it's one of my first addon for WoW, and sorry for my English =)

Изменения/ChangeLog:
v1.1.2 - Первый запуск / Initial Release
v1.1.3 - Небольшие изменения в загрузке плагина; добавлены, изменены и локализованы некоторые подсказки 
         Minor changes in plugin loading; added, modified and localized some tips

--]]

local TITAN_CAMDIST_VERSION = "1.1.3"
local TITAN_CAMDIST_ID = "CamDist"
------------------------------------------------------------------------
if GetLocale() == "ruRU" then TITAN_CAMDIST_TOOLTIPTITLE = "ТитанПанель: Дистанция камеры" 
else TITAN_CAMDIST_TOOLTIPTITLE = "TitanPanel: Camera Distance" end
------------------------------------------------------------------------
if GetLocale() == "ruRU" then TITAN_CAMDIST_TOOLTIPTEXT = "Позволяет изменить максимальную дистанцию обзора камеры \n |cffffffff0|cffffcc00   - вид от первого лица\n |cffffffff25|cffffcc00 - стандартная дистанция \n |cffffffff50|cffffcc00 - максимальная дистанция \n|cff00ff00Правый клик для выбора дистанции.|r"
else TITAN_CAMDIST_TOOLTIPTEXT = "Allows you to change the maximum camera distance \n |cffffffff 0 |cffffcc00  -  first-person view \n |cffffffff25 |cffffcc00 - the standard distance \n |cffffffff50 |cffffcc00 - the maximum distance \n |cff00ff00Right-click to select the distance. |r" end

if GetLocale() == "ruRU" then TITAN_CAMDIST_BUTTONTEXT = "Дистанция"
else TITAN_CAMDIST_BUTTONTEXT = "Distance" end

if GetLocale() == "ruRU" then TITAN_CAMDIST_MENUTEXT = "Дистанция:"
else TITAN_CAMDIST_MENUTEXT = "Distance:" end

if GetLocale() == "ruRU" then TITAN_CAMDIST_HELPTEXT = "Помощь"
else TITAN_CAMDIST_HELPTEXT = "Help" end

if GetLocale() == "ruRU" then TITAN_CAMDIST_HELP = "TitanPanel [CamDist]: Изменение максимальной дистанции камеры сохраняется после выхода из игры. Все дистанции действительны при установленной в Интерфейсе минимальной дистанции камеры (Опции - Интерфейс - Камера)"
else TITAN_CAMDIST_HELP = "TitanPanel [CamDist]: Changing the maximum camera distance is saved after you exit the game. All distances are valid if installed in Interface the low camera distance  (Options - Interface - Camera)" end

if GetLocale() == "ruRU" then TITAN_CAMDIST_METERS = " метров" else TITAN_CAMDIST_METERS = " yards" end
------------------------------------------------------------------------
local f = CreateFrame("Button", "TitanPanelCamDistButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")
------------------------------------------------------------------------
function f:ADDON_LOADED(a1)
	if a1 ~= "TitanCamDist" then return end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	self.registry = {
		id = TITAN_CAMDIST_ID,
        version = TITAN_CAMDIST_VERSION,
		menuText = TITAN_CAMDIST_MENUTEXT,
		buttonTextFunction = "TitanPanelCamDist_GetButtonText",
        tooltipTitle = TITAN_CAMDIST_TOOLTIPTITLE,
        tooltipTextFunction = "TitanPanelCamDist_GetTooltipText",
		icon = "Interface\\Icons\\Spell_Fire_Flare",
		iconWidth = 12,
		category = "Interface",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,},}
end
------------------------------------------------------------------------
function TitanPanelCamDist_GetButtonText()
return TITAN_CAMDIST_BUTTONTEXT
end
------------------------------------------------------------------------
function TitanPanelCamDist_GetTooltipText()
return TITAN_CAMDIST_TOOLTIPTEXT
end
------------------------------------------------------------------------
-- Максимальная дистанция камеры от 0 до 50 / The maximum camera distance from 0 to 50
local function CamDist0()
SetCVar("cameraDistanceMax",0)
end 
local function CamDist2()
SetCVar("cameraDistanceMax",2)
end 
local function CamDist4()
SetCVar("cameraDistanceMax",4)
end 
local function CamDist6()
SetCVar("cameraDistanceMax",6)
end
local function CamDist8()
SetCVar("cameraDistanceMax",8)
end 
local function CamDist10()
SetCVar("cameraDistanceMax",10)
end 
local function CamDist12()
SetCVar("cameraDistanceMax",12)
end 
local function CamDist14()
SetCVar("cameraDistanceMax",14)
end 
local function CamDist16()
SetCVar("cameraDistanceMax",16)
end 
local function CamDist18()
SetCVar("cameraDistanceMax",18)
end 
local function CamDist20()
SetCVar("cameraDistanceMax",20)
end 
local function CamDist22()
SetCVar("cameraDistanceMax",22)
end 
local function CamDist24()
SetCVar("cameraDistanceMax",24)
end
local function CamDist26()
SetCVar("cameraDistanceMax",26)
end 
local function CamDist28()
SetCVar("cameraDistanceMax",28)
end 
local function CamDist30()
SetCVar("cameraDistanceMax",30)
end 
local function CamDist32()
SetCVar("cameraDistanceMax",32)
end 
local function CamDist34()
SetCVar("cameraDistanceMax",34)
end 
local function CamDist36()
SetCVar("cameraDistanceMax",36)
end 
local function CamDist38()
SetCVar("cameraDistanceMax",38)
end 
local function CamDist40()
SetCVar("cameraDistanceMax",40)
end 
local function CamDist42()
SetCVar("cameraDistanceMax",42)
end 
local function CamDist44()
SetCVar("cameraDistanceMax",44)
end 
local function CamDist46()
SetCVar("cameraDistanceMax",46)
end 
local function CamDist48()
SetCVar("cameraDistanceMax",48)
end 
local function CamDist50()
SetCVar("cameraDistanceMax",50)
end 
local function CamDistHelp()
DEFAULT_CHAT_FRAME:AddMessage(format(TITAN_CAMDIST_HELP))
end 
------------------------------------------------------------------------
------------------------------------------------------------------------
function TitanPanelRightClickMenu_PrepareCamDistMenu()
local info;
------------------------------------------------------------------------
-- 2й УРОВЕНЬ / 2nd Menu Level
------------------------------------------------------------------------
        -- Меню 2го уровня, Дистанции 0-10    
        if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then
		if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist10" ) then
        info = {};
		info.text = ("2"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist2() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("4"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist4() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("6"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist6() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("8"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist8() end;
		UIDropDownMenu_AddButton(info,2) 
        end

    -- Меню 2го уровня, Дистанции 10-20   
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist20" ) then
		info = {};
		info.text = ("12"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist12() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("14"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist14() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("16"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist16() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("18"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist18() end;
		UIDropDownMenu_AddButton(info,2) 
        end
   
    -- Меню 2го уровня, Дистанции 20-30          
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist30" ) then
		info = {};
		info.text = ("22"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist22() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("24"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist24() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("26"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist26() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("28"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist28() end;
		UIDropDownMenu_AddButton(info,2) 
        end
        
    -- Меню 2го уровня, Дистанции 30-40          
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist40" ) then
		info = {};
		info.text = ("32"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist32() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("34"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist34() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("36"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist36() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("38"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist38() end;
		UIDropDownMenu_AddButton(info,2) 
        end
        
    -- Меню 2го уровня, Дистанции 40-50         
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist50" ) then
		info = {};
		info.text = ("42"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist42() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("44"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist44() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("46"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist46() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("48"..TITAN_CAMDIST_METERS.."")
        info.func = function() CamDist48() end;
		UIDropDownMenu_AddButton(info,2) 
        end 
        else
        
------------------------------------------------------------------------
-- 1й УРОВЕНЬ / 1st Menu Level
------------------------------------------------------------------------
-- Меню 1го уровня   
   	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_CAMDIST_ID].menuText)
   	info = {};
   	info.text = ("0"..TITAN_CAMDIST_METERS.."")
    info.value = "CamDist0"
    info.func = function() CamDist0() end;
    UIDropDownMenu_AddButton(info);
    
    info = {};
   	info.text = ("10"..TITAN_CAMDIST_METERS.."")
    info.value = "CamDist10"
    info.func = function() CamDist10() end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    
   	info = {};
   	info.text = ("20"..TITAN_CAMDIST_METERS.."")
    info.value = "CamDist20"
    info.func = function() CamDist20() end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);

   	info = {};
   	info.text = ("30"..TITAN_CAMDIST_METERS.."")
    info.hasArrow = 1;
    info.value = "CamDist30"
    info.func = function() CamDist30() end;
    UIDropDownMenu_AddButton(info);

   	info = {};
   	info.text = ("40"..TITAN_CAMDIST_METERS.."")
    info.value = "CamDist40"
    info.func = function() CamDist40() end;
    info.hasArrow = 1
    UIDropDownMenu_AddButton(info);
    
    info = {};
   	info.text = ("50"..TITAN_CAMDIST_METERS.."")
    info.value = "CamDist50"
    info.func = function() CamDist50() end;
    info.hasArrow = 1
    UIDropDownMenu_AddButton(info);
    
    TitanPanelRightClickMenu_AddSpacer()
    
    info = {};
   	info.text = TITAN_CAMDIST_HELPTEXT
    info.value = "CamDistHelp"
    info.func = function() CamDistHelp() end;
    UIDropDownMenu_AddButton(info);
    
	TitanPanelRightClickMenu_AddToggleIcon(TITAN_CAMDIST_ID)  
end
end


-- P.S.: Заки - самый большой склерозник, хоть и когда-то помог мне немного с этим аддОном